pro writeLogFile, savelogcsv, savelogtxt, logFilecsvName, logFiletxtName, csvUnit, txtUnit, header, endline, $
    time, fdbsji, fdbfuv, fdbnuv, crssji, crsfuv, crsnuv, $
    PZTcurrent, nrOBSrepeats, nrFRM, nrFRMrepeats, nrFDB, $
    FW, FRMid, $
    sim1, sim2, sim3, sim4, $
    filedirfuv=filedirfuv, filedirnuv=filedirnuv, datestamp=datestamp, OBSid=OBSid
    
  if header then begin
    ;create header of logfiles
  
    ;create csv-logfile
    if savelogcsv then begin
      logFilecsvName=datestamp+'/AAlog.csv'
      OpenW, csvUnit, logFilecsvName, /get_lun
      log='Log of syntool.pro,OBS ID:,'+OBSid
      printf, csvUnit, log
      log='Path of input files,FUV:,'+filedirfuv+',NUV:,'+filedirnuv
      printf, csvUnit, log
      log='Time [s],PZTx,PZTy,OBSrep,OBSentry,FRMrep,FRMentry,FW,'+$
        'FRM,FDB SJI,FDB FUV,FDB NUV,CRS SJI,CRS FUV,CRS NUV,'+$
        'File 1 FUV,File 2 FUV,File 1 NUV,File 2 NUV'
      printf, csvUnit, log
      Close, csvUnit
    endif
    
    ;create txt-logfile
    if savelogtxt then begin
      logFiletxtName=datestamp+'/AAlog.txt'
      OpenW, txtUnit, logFiletxtName, /get_lun
      log='Log of syntool.pro; OBS ID: '+OBSid
      printf, txtUnit, log
      log='Path of input files; FUV: '+filedirfuv+'; NUV: '+filedirnuv
      printf, txtUnit, log
      log=' Time [s] |    PZTx |    PZTy | OBSrep | OBSentry | FRMrep | FRMentry |  FW | '+$
        '    FRM | FDB SJI | FDB FUV | FDB NUV | CRS SJI | CRS FUV | CRS NUV | '+$
        'File1 F | File2 F | File1 N | File2 N'
      l=strlen(log)
      log2='='
      for i=0,l-2 do log2=log2+'='
      printf, txtUnit, log2
      printf, txtUnit, log
      printf, txtUnit, log2
      Close, txtUnit
    endif
    
  endif else begin
  
    tim=time/1000.
    
    if endline then begin
      ;write last line with the endtime
    
      if savelogcsv then begin
        OpenU, csvUnit, logFilecsvName, /append
        log=string(tim)
        log=strcompress(log,/remove_all)
        printf, csvUnit, log
        Close, csvUnit
        free_lun, csvUnit
      endif
      
      if savelogtxt then begin
        OpenU, txtUnit, logFiletxtName, /append
        log=string(tim, format='(f9.3)')+' |'
        printf, txtUnit, log
        Close, txtUnit
        free_lun, txtUnit
      endif
      
    endif else begin
      ;write data into files
    
      ;write to the csv-log file
      if savelogcsv then begin
        OpenU, csvUnit, logFilecsvName, /append
        log=string(tim)+','+$
          string(PZTcurrent[0])+','+$
          string(PZTcurrent[1])+','+$
          string(nrOBSrepeats+1)+','+$
          string(nrFRM+1)+','+$
          string(nrFRMrepeats+1)+','+$
          string(nrFDB+1)+','+$
          string(FW)+','+$
          FRMid+','+$
          fdbsji+','+$
          fdbfuv+','+$
          fdbnuv+','+$
          crssji+','+$
          crsfuv+','+$
          crsnuv+','+$
          string(sim1)+','+$
          string(sim2)+','+$
          string(sim3)+','+$
          string(sim4)
        log=strcompress(log,/remove_all)
        printf, csvUnit, log
        Close, csvUnit
      endif
      
      ;write to the txt-log file
      if savelogtxt then begin
        for i=strlen(fdbsji),strlen(FRMid)-1 do fdbsji=' '+fdbsji
        for i=strlen(fdbfuv),strlen(FRMid)-1 do fdbfuv=' '+fdbfuv
        for i=strlen(fdbnuv),strlen(FRMid)-1 do fdbnuv=' '+fdbnuv
        for i=strlen(crssji),strlen(FRMid)-1 do crssji=' '+crssji
        for i=strlen(crsfuv),strlen(FRMid)-1 do crsfuv=' '+crsfuv
        for i=strlen(crsnuv),strlen(FRMid)-1 do crsnuv=' '+crsnuv
        OpenU, txtUnit, logFiletxtName, /append
        log=string(tim, format='(f9.3)')+' | '+$
          string(PZTcurrent[0], format='(f7.3)')+' | '+$
          string(PZTcurrent[1], format='(f7.3)')+' | '+$
          string(nrOBSrepeats+1, format='(I6)')+' | '+$
          string(nrFRM+1, format='(I8)')+' | '+$
          string(nrFRMrepeats+1, format='(I6)')+' | '+$
          string(nrFDB+1, format='(I8)')+' | '+$
          string(FW, format='(I3)')+' | '+$
          FRMid+' | '+$
          fdbsji+' | '+$
          fdbfuv+' | '+$
          fdbnuv+' | '+$
          crssji+' | '+$
          crsfuv+' | '+$
          crsnuv+' | '+$
          string(sim1, format='(I7)')+' | '+$
          string(sim2, format='(I7)')+' | '+$
          string(sim3, format='(I7)')+' | '+$
          string(sim4, format='(I7)')
        printf, txtUnit, log
        Close, txtUnit
      endif
      
    endelse
    
  endelse
  
end
